src/main/java/ru/lanolin/lab3/bean/ContrBean.java
package ru.lanolin.lab3.bean;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.SneakyThrows;

import javax.annotation.PostConstruct;
import javax.management.MBeanServer;
import javax.management.ObjectName;
import java.lang.management.ManagementFactory;
import java.time.format.DateTimeFormatter;

@Getter
@NoArgsConstructor
public class ContrBean {

	private final String VERSION = "3";
	private final String VARIANT = "47777";
	private final String AUTHOR = "Киселев Артем";
	private final String GROUP = "P3214";

	private final DateTimeFormatter dateTimeFormatter = DateTimeFormatter.ofPattern("Y-M-d H:m:s");

	private Profiling profiling = new Profiling();

	@PostConstruct
	@SneakyThrows
	public void initPost(){
		MBeanServer mBeanServer = ManagementFactory.getPlatformMBeanServer();
		ObjectName objectName = new ObjectName("ru.lanolin.lab3:type=Profiling,name=profile");
		if(!mBeanServer.isRegistered(objectName))
			mBeanServer.registerMBean(profiling, objectName);
	}

}

src/main/java/ru/lanolin/lab3/bean/FormBean.java
package ru.lanolin.lab3.bean;

import lombok.Getter;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;
import ru.lanolin.lab3.domain.Point;
import ru.lanolin.lab3.dto.PointDTO;
import ru.lanolin.lab3.repo.PointRepo;

import javax.annotation.PostConstruct;
import javax.faces.component.html.HtmlSelectBooleanCheckbox;
import javax.faces.event.ValueChangeEvent;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@Slf4j
public class FormBean implements Serializable {

	@Setter @Getter
	private ContrBean contrBean;

	private PointDTO point;
	private PointDTO canvas;

	@Getter @Setter
	private PointRepo pointRepo;

	public FormBean() {
		this.point = new PointDTO();
		this.canvas = new PointDTO();
	}

	@PostConstruct
	public void postConstruct(){
		this.point.setR(0, true);
	}

	private void logging(String message){
		if(contrBean.getProfiling().isDebugMode())
			log.info(message);
	}

	public void changeSlider(ValueChangeEvent event){
		setX(Integer.parseInt(event.getNewValue().toString()));
		logging("Slider change from " + event.getOldValue() + " to " + event.getNewValue());
	}

	public void changeBooleanListener(ValueChangeEvent event){
		int id = Integer.parseInt(((HtmlSelectBooleanCheckbox) event.getSource()).getId().substring(1)) - 1;
		setR(id, (Boolean) event.getNewValue());
		logging("Change boolean checkbox id " + id);
	}

	public void checkPoint(){
		logging("Click to SUBMIT: " + point);
		createPointAndAddToDB(point);
	}

	public void canvasListener(){
		logging("Add to canvas " + canvas.toString());
		boolean checkR = checkSelectedRadius();
		if(checkR){
			createPointAndAddToDB(canvas);
		}
	}

	private void createPointAndAddToDB(PointDTO pointDTO) {
		List<Point> pointToDB = new ArrayList<>();
		for (int i = 0; i < 5; i++) {
			if (getR(i)) {
				Point p = new Point(0L,
						pointDTO.getX(), pointDTO.getY(), String.valueOf(i + 1),
						pointDTO.isHit(i + 1), LocalDateTime.now());
				pointToDB.add(p);
			}
		}
		pointRepo.addNewPoint(pointToDB);
	}

	public boolean checkSelectedRadius(){
		boolean[] rs = point.getR();
		return rs[0] || rs[1] || rs[2] || rs[3] || rs[4];
	}

	public boolean getReadyToSubmit(){
		boolean checkX = point.getX() != null && !point.getX().isEmpty();
		boolean checkY = point.getY() != null && !point.getY().isEmpty();
		return checkX && checkY && checkSelectedRadius();
	}

	public String getSelectedR(){
		StringBuilder builder = new StringBuilder();
		for(int i = 0; i < 5; i++){
			if(getR(i)){
				builder.append(i+1).append(",");
			}
		}
		return builder.toString();
	}

	public String getAllPoints(){
		StringBuilder builder = new StringBuilder();
		List<PointDTO> pointRepoPoints = pointRepo.getPoints()
				.stream()
				.map(point1 -> new PointDTO(point1.getX(), point1.getY(), null))
				.distinct()
				.collect(Collectors.toList());

		for (PointDTO dto : pointRepoPoints) {
			Boolean hit = false;
			int r = 0;
			for (int i = 0; i < point.getR().length; i++) {
				if(getR(i)) {
					hit = dto.isHit(i + 1);
					if (hit == null) {
						break;
					}
					if (hit) {
						r = i + 1;
						break;
					}
				}else{
					Boolean checkToNull = dto.isHit(i + 1);
					if(checkToNull == null){
						hit = null;
						break;
					}
				}
			}
			if(r == 0) r = 6;
			builder.append("{")
					.append("\"x\":").append(dto.getX()).append(",")
					.append("\"y\":").append(dto.getY()).append(",")
					.append("\"r\":").append(r).append(",")
					.append("\"hit\":").append(hit).append(",")
					.append("},");
		}

		return builder.toString();
	}

	public void setX(Integer x){
		this.point.setX(x.toString());
	}
	public Integer getX(){
		return Integer.parseInt(this.point.getX());
	}

	public void setY(String y){
		this.point.setY(y);
	}
	public String getY(){
		return this.point.getY();
	}

	public void setR(int i, boolean val){
		this.point.setR(i, val);
		this.canvas.setR(i, val);
	}
	public boolean getR(int i){
		return this.point.getR()[i];
	}

	public boolean getOneR(){ return getR(0); }
	public void setOneR(boolean oneR){ this.point.setR(0, oneR); }

	public boolean getTwoR(){ return getR(1); }
	public void setTwoR(boolean oneR){ this.point.setR(1, oneR); }

	public boolean getFreeR(){ return getR(2); }
	public void setFreeR(boolean oneR){ this.point.setR(2, oneR); }

	public boolean getFourR(){ return getR(3); }
	public void setFourR(boolean oneR){ this.point.setR(3, oneR); }

	public boolean getFiveR(){ return getR(4); }
	public void setFiveR(boolean oneR){ this.point.setR(4, oneR); }

	public void setCanvasX(String x){
		this.canvas.setX(x);
	}

	public String getCanvasX(){
		return this.canvas.getX();
	}

	public void setCanvasY(String y){
		this.canvas.setY(y);
	}

	public String getCanvasY(){
		return this.canvas.getY();
	}
}

src/main/java/ru/lanolin/lab3/bean/Profiling.java
package ru.lanolin.lab3.bean;

import lombok.Getter;
import ru.lanolin.lab3.util.ProfilingMXBean;

public class Profiling implements ProfilingMXBean {

	@Getter
	private boolean debugMode;

	public Profiling() {
		this.debugMode = false;
	}

	@Override
	public void setEnable(boolean enable) {
		this.debugMode = enable;
	}

	@Override
	public boolean isEnable() { return debugMode; }
}

src/main/java/ru/lanolin/lab3/domain/Point.java
package ru.lanolin.lab3.domain;

import lombok.*;
import ru.lanolin.lab3.repo.LocalDateTimeAttributeConverter;

import javax.persistence.*;
import java.io.Serializable;
import java.time.LocalDateTime;

@Entity
@Table(name = "points")
@Data
@ToString
@EqualsAndHashCode
@NoArgsConstructor
@AllArgsConstructor
public class Point implements Serializable {

	@Id
	@Column(nullable = false)
	private Long UUID;

	@Column(nullable = false)
	private String x;

	@Column(nullable = false)
	private String y;

	@Column(nullable = false)
	private String r;

	@Column(name = "hit", nullable = true)
	private Boolean check;

	@Column(nullable = false)
	@Convert(converter = LocalDateTimeAttributeConverter.class)
	private LocalDateTime time;

}

src/main/java/ru/lanolin/lab3/dto/PointDTO.java
package ru.lanolin.lab3.dto;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import ru.lanolin.lab3.util.CheckAreaHit;

import java.io.Serializable;
import java.math.BigDecimal;
import java.math.MathContext;

@Data
@AllArgsConstructor
@EqualsAndHashCode(of = {"x", "y"})
public class PointDTO implements Serializable {
	private String x;
	private String y;
	private boolean[] r;

	public PointDTO() {
		this.x = "0";
		this.y = "0";
		this.r = new boolean[] { true, false, false, false, false };
	}

	public void setR(int i, boolean val){ this.r[i] = val; }

	public Boolean isHit(int i){
		return HIT.check(
				new BigDecimal(x),
				new BigDecimal(y),
				new BigDecimal(i)
		);
	}

	public static Boolean isHit(String x, String y, String r){
		return HIT.check(
				new BigDecimal(x),
				new BigDecimal(y),
				new BigDecimal(r)
		);
	}

	private static final CheckAreaHit HIT = (x, y, r) -> {

		if(x.compareTo(BigDecimal.valueOf(-6)) < 0 || x.compareTo(BigDecimal.valueOf(6)) > 0)
			return null;

		if(y.compareTo(BigDecimal.valueOf(-3)) < 0 || y.compareTo(BigDecimal.valueOf(5)) > 0)
			return null;

		int compareX = x.compareTo(BigDecimal.ZERO);
		int compareY = y.compareTo(BigDecimal.ZERO);

		if (compareX >= 0 && compareY >= 0) { //1 четверть
			return x.compareTo(r) <= 0 && y.compareTo(r.divide(BigDecimal.valueOf(2), MathContext.DECIMAL128)) <= 0;
		} else if (compareX <= 0 && compareY >= 0) { //2 четверть
			return y.compareTo(x.add(r)) <= 0;
		} else if (compareX <= 0) {  //3 четверть
			return false;
		} else {  //4 четверть
			return x.pow(2).add(y.pow(2)).compareTo(r.pow(2)) <= 0;
		}
	};
}

src/main/java/ru/lanolin/lab3/util/ProfilingMXBean.java
package ru.lanolin.lab3.util;

public interface ProfilingMXBean {
	void setEnable(boolean enable);
	boolean isEnable();
}

src/main/webapp/index.xhtml
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:ace="http://www.icefaces.org/icefaces/components"
      xmlns:ui="http://java.sun.com/jsf/facelets">

<h:head>
    <title>Лабораторная <h:outputText value="#{info.VERSION}"/></title>
    <link href="static/style/style.css" rel="stylesheet"/>
    <link href="static/style/w3.css" rel="stylesheet"/>
</h:head>

<h:body>
    <header>
        <h1 style="margin-top: 5px; margin-bottom: -5px;">
            <button class="w3-btn w3-border-0" id="reload">Попадание в область</button>
        </h1>
        <h:outputText value="#{info.AUTHOR}"/> группа <h:outputText value="#{info.GROUP}"/> <br/>
        Вариант <h:outputText value="#{info.VARIANT}"/>
    </header>

    <article class="work">
        <div id="clock">
            <p class="date">{{ date }}</p>
            <p class="time">{{ time }}</p>
        </div>

        <h:form style="position: relative; top: 45%;">
            <h:commandButton
                    styleClass="history-button buttons w3-btn w3-white w3-border w3-border-green w3-round-xlarge"
                    action="goonview"
                    value="Войти на сайт"
            />
        </h:form>

    </article>

    <footer>Copyright. All rights reserved. 2019</footer>

    <script src="/static/js/index.js"></script>
</h:body>
</html>

src/main/webapp/views.xhtml
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:ace="http://www.icefaces.org/icefaces/components"
      xmlns:ui="http://java.sun.com/jsf/facelets">

<h:head>
    <title>Лабораторная #{info.VERSION}</title>
    <link href="static/style/style.css" rel="stylesheet"/>
    <link href="static/style/w3.css" rel="stylesheet"/>
</h:head>

<h:body>
    <script>
        let graphics = undefined;
        let selectedR = [ #{formPoint.selectedR} ];
        let points = [ #{formPoint.allPoints} ];
    </script>
    <header>
        <h1 style="margin-top: 5px; margin-bottom: -5px;">
            <button class="w3-btn w3-border-0" id="reload">Попадание в область</button>
        </h1>
        <h:outputText value="#{info.AUTHOR}"/> группа <h:outputText value="#{info.GROUP}"/> <br/>
        Вариант <h:outputText value="#{info.VARIANT}"/>
    </header>

    <article class="work">
        <div class="graphic" style="float: right;">
            <h:form id="canvas-click" >
                <h:inputHidden id="xCanvas" value="#{formPoint.canvasX}" />
                <h:inputHidden id="yCanvas" value="#{formPoint.canvasY}" />
                <canvas id="canvas_1" width="250px" height="250px" />
                <canvas id="canvas_2" width="250px" height="250px" />

                <h:commandScript name="clickCanvas"
                                 execute="@form"
                                 action="#{formPoint.canvasListener}"
                                 render="result-point canvas-new-point" />

                <h:panelGroup id="canvas-new-point">
                    <script type="text/javascript">
                        if(graphics){
                            points = [ #{formPoint.allPoints} ];
                            graphics.drawBackground();
                            graphics.changeGraphicsRadius([ #{formPoint.selectedR} ], [ #{formPoint.allPoints} ]);
                        }
                    </script>
                </h:panelGroup>
            </h:form>
        </div>
        <h:form id="sendD">
            <table border="1px" id="mainForm" style="position: relative; width: 500px;">
                <tr style="height: 45px">
                    <th>Поле</th>
                    <th>Значение</th>
                </tr>
                <tr>
                    <td><h:outputLabel for="X" title="X" value="X" /></td>
                    <td style="height: 30px;">
                        <ace:sliderEntry style="margin-left: auto;margin-right: auto;margin-top: 15px;margin-bottom: -11px;width: 280px;"
                                id="X" length="200px"
                                min="-5" value="#{formPoint.x}" max="5" stepPercent="10"
                                showLabels="true"
                                valueChangeListener="#{formPoint.changeSlider}" >
                            <ace:ajax event="slide" execute="@this" render="X-text submit-btn" />
                        </ace:sliderEntry>
                        <h:outputLabel id="X-text" value="#{formPoint.x}" style="position: relative; top: -15px;" />
                    </td>
                </tr>
                <tr>
                    <td><h:outputLabel for="Y" title="Y" value="Y" /> </td>
                    <td>
                        <h:inputText id="Y"
                                     value="#{formPoint.y}"
                                     required="true"
                                     requiredMessage="Поле является пустым"
                                     validatorMessage="Число вышло за ОДЗ"
                                     converterMessage="Введено не число"
                                     title="от -3 до 5">
                            <f:converter converterId="javax.faces.BigDecimal" />
                            <f:validator validatorId="y-validator" />
                            <f:ajax event="keyup" render="errY submit-btn" />-->
                        </h:inputText>
                        <h:message for="Y" id="errY" styleClass="warn"/>
                    </td>
                </tr>
                <tr>
                    <td><label>R</label></td>
                    <td>
                        <h:selectBooleanCheckbox
                                id="R1" value="#{formPoint.oneR}"
                                label="1" title="1"
                                valueChangeListener="#{formPoint.changeBooleanListener}">
                            <f:ajax event="click" render="submit-btn radius-for-canvas"/>
                        </h:selectBooleanCheckbox>
                        <h:outputLabel title="1" value="1" for="R1" style="margin-left: 5px; margin-right: 20px;" />
                        <h:selectBooleanCheckbox
                                id="R2" value="#{formPoint.twoR}"
                                label="2" title="2"
                                valueChangeListener="#{formPoint.changeBooleanListener}">
                            <f:ajax event="click" render="submit-btn radius-for-canvas"/>
                        </h:selectBooleanCheckbox>
                        <h:outputLabel title="2" value="2" for="R2" style="margin-left: 5px; margin-right: 20px;" />
                        <h:selectBooleanCheckbox
                                id="R3" value="#{formPoint.freeR}"
                                label="3" title="3"
                                valueChangeListener="#{formPoint.changeBooleanListener}">
                            <f:ajax event="click" render="submit-btn radius-for-canvas"/>
                        </h:selectBooleanCheckbox>
                        <h:outputLabel title="3" value="3" for="R3" style="margin-left: 5px; margin-right: 20px;" />
                        <h:selectBooleanCheckbox
                                id="R4" value="#{formPoint.fourR}"
                                label="4" title="4"
                                valueChangeListener="#{formPoint.changeBooleanListener}">
                            <f:ajax event="click" render="submit-btn radius-for-canvas"/>
                        </h:selectBooleanCheckbox>
                        <h:outputLabel title="4" value="4" for="R4" style="margin-left: 5px; margin-right: 20px;" />
                        <h:selectBooleanCheckbox
                                id="R5" value="#{formPoint.fiveR}"
                                label="5" title="5"
                                valueChangeListener="#{formPoint.changeBooleanListener}">
                            <f:ajax event="click" render="submit-btn radius-for-canvas"/>
                        </h:selectBooleanCheckbox>
                        <h:outputLabel title="5" value="5" for="R5" style="margin-left: 5px; margin-right: 20px;" />

                        <h:message for="R1" id="errR" styleClass="warn"/>
                        <h:panelGroup id="radius-for-canvas">
                            <script>
                                if(graphics){
                                    graphics.changeGraphicsRadius([ #{formPoint.selectedR} ], [ #{formPoint.allPoints} ]);
                                }
                            </script>
                        </h:panelGroup>
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                        <h:form style="position: relative; top: 45%;">
                            <h:commandButton
                                    styleClass="history-button buttons w3-btn w3-white w3-border w3-border-green w3-round-xlarge"
                                    action="goonmain"
                                    value="Выйти на главное"
                            />
                        </h:form>
                        <h:commandButton id="submit-btn"
                                         styleClass="buttons w3-btn w3-white w3-border w3-border-green w3-round-xlarge"
                                         action="#{formPoint.checkPoint}"
                                         value="Проверить"
                                         disabled="#{!formPoint.readyToSubmit}" >
                            <f:ajax execute="@form" render="send-data result-point" />
                        </h:commandButton>
                        <h:panelGroup id="send-data">
                            <script>
                                if(graphics){
                                    graphics.drawBackground();
                                    graphics.changeGraphicsRadius(selectedR, [ #{formPoint.allPoints} ]);
                                }
                            </script>
                        </h:panelGroup>
                    </td>
                </tr>
            </table>
        </h:form>

        <div id="result-div-table" style="width: 760px; height: 230px; overflow:auto;" >
            <h:dataTable id="result-point"
                    value="#{pointRepo.points}" var="p"
                    styleClass="order-table"
                    headerClass="order-table-header"
                    rowClasses="order-table-odd-row,order-table-even-row">
                <h:column>
                    <f:facet name="header">X</f:facet>
                    <h:panelGroup>
                        <h:outputText value="#{p.x}" />
                    </h:panelGroup>
                </h:column>
                <h:column>
                    <f:facet name="header">Y</f:facet>
                    <h:panelGroup>
                        <h:outputText value="#{p.y}" />
                    </h:panelGroup>
                </h:column>
                <h:column>
                    <f:facet name="header">R</f:facet>
                    <h:panelGroup>
                        <h:outputText value="#{p.r}" />
                    </h:panelGroup>
                </h:column>
                <h:column>
                    <f:facet name="header">Hit</f:facet>
                    <h:panelGroup>
                        <h:outputText value="Undefined" style="color: grey;" rendered="#{p.check == null}"/>
                        <h:outputText value="True" style="color: green;" rendered="#{p.check != null and p.check}" />
                        <h:outputText value="False" style="color: red;" rendered="#{p.check != null and !p.check}" />
                    </h:panelGroup>
                </h:column>
                <h:column>
                    <f:facet name="header">Time</f:facet>
                    <h:panelGroup>
                        <h:outputText value="#{p.time.format(info.dateTimeFormatter)}" />
                    </h:panelGroup>
                </h:column>
            </h:dataTable>
        </div>
    </article>

    <footer>Copyright. All rights reserved. 2019</footer>

    <script src="/static/js/view.js"></script>

    <script>
        graphics.drawBackground();
        graphics.drawArea(selectedR);
        graphics.drawPoint(points);
    </script>
</h:body>
</html>